<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="true"
    :dropdown-menu="dropdownMenu"
    :is-active-element="selectedData.active"
    @change-active="onChangeActive"
    class="etsng-form"
  >
    <div class="row">
      <div class="col-xs-4">
        <ob-input
          :label="dictionaryRu.modal.code"
          v-model="selectedData.code"
          :disabled="true"
        />
      </div>
      <div class="col-xs-4">
        <ob-select
          :label="dictionaryRu.modal.cargo_class"
          v-model="selectedData.cargo_class"
          :items="[{class: selectedData.cargo_class}]"
          :disabled="true"
          display-exp="class"
          value-exp="class"
          placeholder
        />
      </div>
      <div class="col-xs-4">
        <ob-input
          v-model="selectedData.cargo_group"
          :label="dictionaryRu.modal.cargo_group"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          v-model="selectedData.denomination"
          :label="dictionaryRu.modal.denomination"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          v-model="selectedData.short_denomination"
          :label="dictionaryRu.modal.short_denomination"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          :label="dictionaryRu.modal.gng_code_names"
          v-model="gngCodeNames"
          :disabled="true"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import api from "@/api";
import ObInput               from 'common-components/src/obComponents/obInput';
import ObTextarea            from 'common-components/src/obComponents/obTextarea';
import ObForm                from 'common-components/src/obComponents/obForm';
import ObSelect              from 'common-components/src/obComponents/obSelect';
import FormValidationMixin   from 'common-components/src/obComponents/obForm/FormValidationMixin';
import dropdownEvents        from '@/mixins/dictionaries/dropdown-events';
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__cargo__etsng'

export default {
  name: 'EmsCode',
  components: {
    ObTextarea,
    ObInput,
    ObForm,
    ObSelect
  },
  props: {
    selectedData: {
      type: Object,
      required: true,
      default: () => {}
    },
    imageData: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  computed: {
    formModel() {
      return this.selectedData;
    },
    gngCodeNames() {
      if (this.selectedData.gng_code_names) {
        return this.selectedData.gng_code_names.reduce((previous, item) => {
          return previous + item.code + ', ' + item.denomination + '; ';
        }, '');
      }
      return '';
    },
    dropdownMenu() {
      return [
        {
          title: 'Удалить',
          className: 'color-error',
          method: () => {
            this.$emit('delete')
          }
        }
      ]
    },
  },
  mixins: [
    FormValidationMixin,
    dropdownEvents
  ],
  methods: {
    async onChangeActive() {
      this.selectedData.active = !this.selectedData.active;
      try {
        await api.cargo.changeEtsngStatus(this.selectedData.uuid, this.selectedData.active);
        this.$notification({ type: 'system_notification_success', message: 'Статус успешно изменен' });
        this.$emit('refresh')
      } catch (e) {
        this.$notification({ type: 'system_notification_error', message: 'Ошибка смены статуса' })
      }
      // await Client.put(this.api.source + 'change_status/' + this.selectedData.uuid, { isActive: this.selectedData.active })
    },
  }
};
</script>

<style lang="scss" scoped>
.image-uploader {
  position: relative;

  .image-tmbs {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    overflow: hidden;
    border-radius: 5px !important;
    background-size: cover;
    background-position: center center;
  }
}

.etsng-form {
  &::v-deep {
    .ob-form-controls-container .form-controls__is-active:not(:last-child) {
      margin-right: 0;
    }
  }
}
</style>
